/*
    Copyright (C) 2000-2007 Paul Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: configuration.h,v 1.2 2000/11/25 00:10:31 pbd Exp $
*/

#ifndef __sw_configuration_h__
#define __sw_configuration_h__

#include <string>
#include <map>
#include <pbd/xml++.h>

class Configuration 
{
  public:
	Configuration ();

	std::map<std::string,XMLNode> midi_ports;

	bool use_real_time;
	int real_time_priority;
	std::string              default_midi_in;
	std::string              default_midi_out;
	unsigned int n_steps;
	unsigned int n_sequences;
	Glib::ustring knob_image;
	Glib::ustring ui_rcfile;
	Glib::ustring pattern_directory;
	Glib::ustring keybindings_path;
	size_t ticks_per_beat;

	static std::string find_config_file (string name);

  private:
	void set_defaults ();
	int load ();
	int set_state (const XMLNode& root);
	
	static std::string find_file (string name, string dir, string subdir = "");
	static std::string get_user_softwerk_path ();

};

extern Configuration *Config;

#endif /* __sw_configuration_h__ */
