#ifndef __sw_trigger_ui_h__
#define __sw_trigger_ui_h__

#include <vector>

#include <gtkmm.h>

class Trigger;

class TriggerUI : public Gtk::Dialog

{
  public:
	TriggerUI (Trigger &, bool with_delete);
	~TriggerUI () {};

	Trigger &trigger() { return _trigger; }

  private:
	Trigger& _trigger;
	
	Gtk::ComboBoxText typeSelector;
	Gtk::ComboBoxText sourceSelector;
	
	Gtk::ComboBoxText portSelector;
	Gtk::Adjustment channelAdjustment;
	Gtk::SpinButton channelSelector;

	Gtk::ComboBoxText   controllerSelector;
	Gtk::Adjustment valueAdjustment;
	Gtk::SpinButton valueSelector;

	Gtk::Entry nameEntry;

	/* Labels */

	Gtk::Label typeSelectorLabel;
	Gtk::Label sourceSelectorLabel;
	Gtk::Label portSelectorLabel;
	Gtk::Label channelSelectorLabel;
	Gtk::Label controllerSelectorLabel;
	Gtk::Label valueSelectorLabel;
	Gtk::Label nameEntryLabel;

	/* Boxes to pack everything into */

	Gtk::HBox portBox;
	Gtk::HBox numbersBox;
	Gtk::HBox typeBox;
	Gtk::HBox nameBox;

	Gtk::VBox typeSelectorBox;
	Gtk::VBox sourceSelectorBox;
	Gtk::VBox channelSelectorBox;
	Gtk::VBox valueSelectorBox;
	Gtk::VBox nameEntryBox;
	Gtk::VBox portSelectorBox;
	Gtk::VBox controllerSelectorBox;

	static bool have_descriptive_strings;
	static void get_descriptive_strings ();

	static std::vector<std::string> source_strings;
	static std::vector<std::string> type_strings;

	void map ();

	void type_change ();
	void source_change ();
	void channel_change ();
	void port_change ();
	void value_change ();
	void controller_change ();
	void name_change ();
	void cancel_click ();
	void ok_click ();
	void delete_click ();
};

#endif /* __sw_trigger_ui_h__ */
