/*
    Copyright (C) 1998-2007 Paul Davis 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: volume_controller.h,v 1.4 2000/05/03 15:54:21 pbd Exp $
*/

#ifndef __vol_controller_h__
#define __vol_controller_h__

#include <gtkmm.h>
#include <gtkmm2ext/popup.h>
#include <midi++/controllable.h>
#include <gtkmm2ext/motionfeedback.h>

class Module;
class Pix;
class Sequence;

class VolumeController : public MIDI::Controllable, public Gtkmm2ext::MotionFeedback
{
  public:
	VolumeController (Glib::RefPtr<Gdk::Pixbuf>,
			  Sequence &seq,
			  Gtk::Adjustment *adj,
			  bool with_numeric = true);

        virtual ~VolumeController () {}

	void set_value (float v);
	void midi_set_tip ();

  protected:
	void timed_out ();
	friend gint learning_timeout (void *);

  private:
	Sequence &sequence;
	Gtk::Adjustment *adjustment;
	Gtkmm2ext::PopUp prompter;
	gfloat new_value;
	bool new_value_pending;
	friend int update_controller_value (void *);
	void do_adjustment ();
	gint button_press (GdkEventButton *);
	gint timeout_tag;

	void prompt ();
	void unprompt ();
	void reset_midi ();

	static gint update_controller_value (void *);
};

#endif // __vol_controller_h__		


